Gecode::Int::Bool::NaryOr< VX, VY > Class Template Reference
Other available functionality » Integer propagators

Boolean n-ary disjunction propagator. More...

`#include <bool.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Give advice to propagator.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low unary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &x, VY y)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| NaryOr (Home home, ViewArray< VX > &x, VY y)
| Constructor for posting.
| NaryOr (Space &home, NaryOr< VX, VY > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::MixNaryOnePropagator< VX, PC_BOOL_NONE, VY, PC_BOOL_VAL >
| MixNaryOnePropagator (Space &home, MixNaryOnePropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

int | n_zero
| The number of views assigned to zero in x.
Council< Advisor > | c
| The advisor council.
Protected Attributes inherited from Gecode::MixNaryOnePropagator< VX, PC_BOOL_NONE, VY, PC_BOOL_VAL >
ViewArray< VX > | x
| Array of views.
VY | y
| Single view.

## Detailed Description

template<class VX, class VY>
class Gecode::Int::Bool::NaryOr< VX, VY >

Boolean n-ary disjunction propagator.

Requires

#include <gecode/int/bool.hh>
bool.hh

Definition at line 355 of file bool.hh.

## Constructor & Destructor Documentation

## NaryOr() [1/2]

template<class VX, class VY>

Gecode::Int::Bool::NaryOr< VX, VY >::NaryOr | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | VY | y )

inline protected

Constructor for posting.

Definition at line 736 of file or.hpp.

## NaryOr() [2/2]

template<class VX, class VY>

Gecode::Int::Bool::NaryOr< VX, VY >::NaryOr | ( | Space & | home,
|  | NaryOr< VX, VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 744 of file or.hpp.

## Member Function Documentation

## copy()

template<class VX, class VY>

Actor * Gecode::Int::Bool::NaryOr< VX, VY >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 752 of file or.hpp.

## advise()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::NaryOr< VX, VY >::advise | ( | Space & | home,
|  | Advisor & | a,
|  | const Delta & | d )

virtual

Give advice to propagator.

Reimplemented from Gecode::Propagator.

Definition at line 805 of file or.hpp.

## cost()

template<class VX, class VY>

PropCost Gecode::Int::Bool::NaryOr< VX, VY >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low unary).

Reimplemented from Gecode::MixNaryOnePropagator< VX, PC_BOOL_NONE, VY, PC_BOOL_VAL >.

Definition at line 799 of file or.hpp.

## reschedule()

template<class VX, class VY>

void Gecode::Int::Bool::NaryOr< VX, VY >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Reimplemented from Gecode::MixNaryOnePropagator< VX, PC_BOOL_NONE, VY, PC_BOOL_VAL >.

Definition at line 815 of file or.hpp.

## propagate()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::NaryOr< VX, VY >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 839 of file or.hpp.

## post()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::NaryOr< VX, VY >::post | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | VY | y )

inline static

Post propagator .

Definition at line 769 of file or.hpp.

## dispose()

template<class VX, class VY>

size_t Gecode::Int::Bool::NaryOr< VX, VY >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::MixNaryOnePropagator< VX, PC_BOOL_NONE, VY, PC_BOOL_VAL >.

Definition at line 828 of file or.hpp.

## Member Data Documentation

## n_zero

template<class VX, class VY>

int Gecode::Int::Bool::NaryOr< VX, VY >::n_zero

protected

The number of views assigned to zero in x.

Definition at line 361 of file bool.hh.

## c

template<class VX, class VY>

Council<Advisor> Gecode::Int::Bool::NaryOr< VX, VY >::c

protected

The advisor council.

Definition at line 363 of file bool.hh.

The documentation for this class was generated from the following files:

- gecode/int/bool.hh
- gecode/int/bool/or.hpp